/* Comp 116 Spring 2021, programming assignment 5
 * Copyright (c) 2021
 * Wheaton College, Computer Science Department, Norton MA
 * M. Gagne
 */

#include <string>
#include <unordered_map>
#include <vector>
#include <utility>
#include <stdexcept>
#include "myDictionary.h"
#include "position.h"

using namespace std;

MyDictionary::MyDictionary() {}

MyDictionary::~MyDictionary() {}



bool MyDictionary::isEmpty() {
  return this->theMap.empty();
}


int MyDictionary::getSize() {
  return this->theMap.size();
}


void MyDictionary::insert(string key, Position* value) {
  if (this->theMap.find(key) != this->theMap.end()) {
    throw runtime_error("MyDictionary::insert, element is already in the dictionary.");
  } else {
    this->theMap[key] = value;
  }
}


void MyDictionary::update(string key, Position* value) {
  if (this->theMap.find(key) == this->theMap.end()) {
    throw runtime_error("MyDictionary::update, element is not in the dictionary.");
  } else {
    this->theMap[key] = value;
  }
}


Position* MyDictionary::find(string key) {
  if (this->theMap.find(key) == this->theMap.end()) {
    throw runtime_error("MyDictionary::find, element is not in the dictionary.");
  } else {
    return this->theMap[key];
  }
}


bool MyDictionary::contains(string key) {
  return this->theMap.find(key) != this->theMap.end();
}


void MyDictionary::remove(string key) {
  if (this->theMap.find(key) == this->theMap.end()) {
    throw runtime_error("MyDictionary::remove, element is not in the dictionary.");
  } else {
    this->theMap.erase(key);
  }

}


vector<string> MyDictionary::getKeys() {
  vector<string> keys;
  for (auto it = this->theMap.begin(); it != this->theMap.end(); it++) {
    keys.push_back(it->first);
  }
  return keys;
}


vector<pair<string,Position*>> MyDictionary::getItems() {
  vector<pair<string,Position*>> items;
  for (auto it = this->theMap.begin(); it != this->theMap.end(); it++) {
    items.push_back(*it);
  }
  return items;
}
